My Project: FVarLevel Class Reference

| My Project

Classes | Public Types | Public Member Functions | Friends | List of all members
FVarLevel Class Reference

`#include <fvarLevel.h>`

## Classes
struct | CreaseEndPair
struct | ETag
struct | ValueTag

## Public Types
typedef Vtr::ConstArray< ValueTag > | ConstValueTagArray
typedef Vtr::Array< ValueTag > | ValueTagArray
typedef Vtr::ConstArray< CreaseEndPair > | ConstCreaseEndPairArray
typedef Vtr::Array< CreaseEndPair > | CreaseEndPairArray
typedef LocalIndex | Sibling
typedef ConstLocalIndexArray | ConstSiblingArray
typedef LocalIndexArray | SiblingArray

## Public Member Functions
| FVarLevel (Level const &level)
| ~FVarLevel ()
Level const & | getLevel () const
int | getNumValues () const
int | getNumFaceValuesTotal () const
bool | isLinear () const
bool | hasLinearBoundaries () const
bool | hasSmoothBoundaries () const
bool | hasCreaseEnds () const
Sdc::Options | getOptions () const
ConstIndexArray | getFaceValues (Index fIndex) const
IndexArray | getFaceValues (Index fIndex)
ETag | getEdgeTag (Index eIndex) const
bool | edgeTopologyMatches (Index eIndex) const
int | getNumVertexValues (Index v) const
Index | getVertexValueOffset (Index v, Sibling i=0) const
Index | getVertexValue (Index v, Sibling i=0) const
Index | findVertexValueIndex (Index vertexIndex, Index valueIndex) const
ConstIndexArray | getVertexValues (Index vIndex) const
IndexArray | getVertexValues (Index vIndex)
ConstValueTagArray | getVertexValueTags (Index vIndex) const
ValueTagArray | getVertexValueTags (Index vIndex)
ConstCreaseEndPairArray | getVertexValueCreaseEnds (Index vIndex) const
CreaseEndPairArray | getVertexValueCreaseEnds (Index vIndex)
ConstSiblingArray | getVertexFaceSiblings (Index vIndex) const
SiblingArray | getVertexFaceSiblings (Index vIndex)
ValueTag | getValueTag (Index valueIndex) const
bool | valueTopologyMatches (Index valueIndex) const
CreaseEndPair | getValueCreaseEndPair (Index valueIndex) const
void | getFaceValueTags (Index faceIndex, ValueTag valueTags[]) const
ValueTag | getFaceCompositeValueTag (Index faceIndex) const
void | getEdgeFaceValues (Index eIndex, int fIncToEdge, Index valuesPerVert[2]) const
void | getVertexEdgeValues (Index vIndex, Index valuesPerEdge[]) const
void | getVertexCreaseEndValues (Index vIndex, Sibling sibling, Index endValues[2]) const
void | setOptions (Sdc::Options const &options)
void | resizeVertexValues (int numVertexValues)
void | resizeValues (int numValues)
void | resizeComponents ()
void | completeTopologyFromFaceValues (int regBoundaryValence)
void | initializeFaceValuesFromFaceVertices ()
void | initializeFaceValuesFromVertexFaceSiblings ()
void | gatherValueSpans (Index vIndex, ValueSpan *vValueSpans) const
bool | validate () const
void | print () const
void | buildFaceVertexSiblingsFromVertexFaceSiblings (std::vector< Sibling > &fvSiblings) const

## Friends
class | FVarRefinement

## Detailed Description

Definition at line 78 of file fvarLevel.h.

## Member Typedef Documentation

## ◆ ConstCreaseEndPairArray

typedef Vtr::ConstArray<CreaseEndPair> ConstCreaseEndPairArray

Definition at line 163 of file fvarLevel.h.

## ◆ ConstSiblingArray

typedef ConstLocalIndexArray ConstSiblingArray

Definition at line 168 of file fvarLevel.h.

## ◆ ConstValueTagArray

typedef Vtr::ConstArray<ValueTag> ConstValueTagArray

Definition at line 150 of file fvarLevel.h.

## ◆ CreaseEndPairArray

typedef Vtr::Array<CreaseEndPair> CreaseEndPairArray

Definition at line 164 of file fvarLevel.h.

## ◆ Sibling

typedef LocalIndex Sibling

Definition at line 166 of file fvarLevel.h.

## ◆ SiblingArray

typedef LocalIndexArray SiblingArray

Definition at line 169 of file fvarLevel.h.

## ◆ ValueTagArray

typedef Vtr::Array<ValueTag> ValueTagArray

Definition at line 151 of file fvarLevel.h.

## Constructor & Destructor Documentation

## ◆ FVarLevel()

FVarLevel | ( | Level const & | level | ) |

## ◆ ~FVarLevel()

~FVarLevel | ( |  | ) |

## Member Function Documentation

## ◆ buildFaceVertexSiblingsFromVertexFaceSiblings()

void buildFaceVertexSiblingsFromVertexFaceSiblings | ( | std::vector< Sibling > & | fvSiblings | ) | const

## ◆ completeTopologyFromFaceValues()

void completeTopologyFromFaceValues | ( | int | regBoundaryValence | ) |

## ◆ edgeTopologyMatches()

bool edgeTopologyMatches | ( | Index | eIndex | ) | const
| inline

Definition at line 194 of file fvarLevel.h.

## ◆ findVertexValueIndex()

Index findVertexValueIndex | ( | Index | vertexIndex,
|  | Index | valueIndex
| ) |  | const
| inline

Definition at line 373 of file fvarLevel.h.

## ◆ gatherValueSpans()

void gatherValueSpans | ( | Index | vIndex,
|  | ValueSpan * | vValueSpans
| ) |  | const

## ◆ getEdgeFaceValues()

void getEdgeFaceValues | ( | Index | eIndex,
|  | int | fIncToEdge,
|  | Index | valuesPerVert[2]
| ) |  | const

## ◆ getEdgeTag()

ETag getEdgeTag | ( | Index | eIndex | ) | const
| inline

Definition at line 193 of file fvarLevel.h.

## ◆ getFaceCompositeValueTag()

ValueTag getFaceCompositeValueTag | ( | Index | faceIndex | ) | const

## ◆ getFaceValues() [1/2]

IndexArray getFaceValues | ( | Index | fIndex | ) |
| inline

Definition at line 305 of file fvarLevel.h.

## ◆ getFaceValues() [2/2]

ConstIndexArray getFaceValues | ( | Index | fIndex | ) | const
| inline

Definition at line 298 of file fvarLevel.h.

## ◆ getFaceValueTags()

void getFaceValueTags | ( | Index | faceIndex,
|  | ValueTag | valueTags[]
| ) |  | const

## ◆ getLevel()

Level const& getLevel | ( |  | ) | const
| inline

Definition at line 176 of file fvarLevel.h.

## ◆ getNumFaceValuesTotal()

int getNumFaceValuesTotal | ( |  | ) | const
| inline

Definition at line 179 of file fvarLevel.h.

## ◆ getNumValues()

int getNumValues | ( |  | ) | const
| inline

Definition at line 178 of file fvarLevel.h.

## ◆ getNumVertexValues()

int getNumVertexValues | ( | Index | v | ) | const
| inline

Definition at line 197 of file fvarLevel.h.

## ◆ getOptions()

Sdc::Options getOptions | ( |  | ) | const
| inline

Definition at line 186 of file fvarLevel.h.

## ◆ getValueCreaseEndPair()

CreaseEndPair getValueCreaseEndPair | ( | Index | valueIndex | ) | const
| inline

Definition at line 221 of file fvarLevel.h.

## ◆ getValueTag()

ValueTag getValueTag | ( | Index | valueIndex | ) | const
| inline

Definition at line 218 of file fvarLevel.h.

## ◆ getVertexCreaseEndValues()

void getVertexCreaseEndValues | ( | Index | vIndex,
|  | Sibling | sibling,
|  | Index | endValues[2]
| ) |  | const

## ◆ getVertexEdgeValues()

void getVertexEdgeValues | ( | Index | vIndex,
|  | Index | valuesPerEdge[]
| ) |  | const

## ◆ getVertexFaceSiblings() [1/2]

FVarLevel::SiblingArray getVertexFaceSiblings | ( | Index | vIndex | ) |
| inline

Definition at line 320 of file fvarLevel.h.

## ◆ getVertexFaceSiblings() [2/2]

FVarLevel::ConstSiblingArray getVertexFaceSiblings | ( | Index | vIndex | ) | const
| inline

Definition at line 313 of file fvarLevel.h.

## ◆ getVertexValue()

Index getVertexValue | ( | Index | v,
|  | Sibling | i = `0`
| ) |  | const
| inline

Definition at line 200 of file fvarLevel.h.

## ◆ getVertexValueCreaseEnds() [1/2]

FVarLevel::CreaseEndPairArray getVertexValueCreaseEnds | ( | Index | vIndex | ) |
| inline

Definition at line 365 of file fvarLevel.h.

## ◆ getVertexValueCreaseEnds() [2/2]

FVarLevel::ConstCreaseEndPairArray getVertexValueCreaseEnds | ( | Index | vIndex | ) | const
| inline

Definition at line 358 of file fvarLevel.h.

## ◆ getVertexValueOffset()

Index getVertexValueOffset | ( | Index | v,
|  | Sibling | i = `0`
| ) |  | const
| inline

Definition at line 198 of file fvarLevel.h.

## ◆ getVertexValues() [1/2]

IndexArray getVertexValues | ( | Index | vIndex | ) |
| inline

Definition at line 335 of file fvarLevel.h.

## ◆ getVertexValues() [2/2]

ConstIndexArray getVertexValues | ( | Index | vIndex | ) | const
| inline

Definition at line 328 of file fvarLevel.h.

## ◆ getVertexValueTags() [1/2]

FVarLevel::ValueTagArray getVertexValueTags | ( | Index | vIndex | ) |
| inline

Definition at line 350 of file fvarLevel.h.

## ◆ getVertexValueTags() [2/2]

FVarLevel::ConstValueTagArray getVertexValueTags | ( | Index | vIndex | ) | const
| inline

Definition at line 343 of file fvarLevel.h.

## ◆ hasCreaseEnds()

bool hasCreaseEnds | ( |  | ) | const
| inline

Definition at line 184 of file fvarLevel.h.

## ◆ hasLinearBoundaries()

bool hasLinearBoundaries | ( |  | ) | const
| inline

Definition at line 182 of file fvarLevel.h.

## ◆ hasSmoothBoundaries()

bool hasSmoothBoundaries | ( |  | ) | const
| inline

Definition at line 183 of file fvarLevel.h.

## ◆ initializeFaceValuesFromFaceVertices()

void initializeFaceValuesFromFaceVertices | ( |  | ) |

## ◆ initializeFaceValuesFromVertexFaceSiblings()

void initializeFaceValuesFromVertexFaceSiblings | ( |  | ) |

## ◆ isLinear()

bool isLinear | ( |  | ) | const
| inline

Definition at line 181 of file fvarLevel.h.

## ◆ print()

void print | ( |  | ) | const

## ◆ resizeComponents()

void resizeComponents | ( |  | ) |

## ◆ resizeValues()

void resizeValues | ( | int | numValues | ) |

## ◆ resizeVertexValues()

void resizeVertexValues | ( | int | numVertexValues | ) |

## ◆ setOptions()

void setOptions | ( | Sdc::Options const & | options | ) |

## ◆ validate()

bool validate | ( |  | ) | const

## ◆ valueTopologyMatches()

bool valueTopologyMatches | ( | Index | valueIndex | ) | const
| inline

Definition at line 219 of file fvarLevel.h.

## Friends And Related Function Documentation

## ◆ FVarRefinement

friend class FVarRefinement
| friend

Definition at line 254 of file fvarLevel.h.

The documentation for this class was generated from the following file:

- opensubdiv/vtr/fvarLevel.h